-- Author      : Xamdnarg
-- Create Date : 4/18/2009 1:51:09 AM

function MyNPCCreate_Process()
	local keywords = MyNPC_KeyWordsEditBox:GetText()
	local answers = string.gsub(MyNPC_AnswersEditBox:GetText(), "\\n", "\n");
	if answers~="" then
		local CurrentZoneId = GetCurrentMapContinent().."-"..GetCurrentMapZone();
		local UnitId = UnitGUID("target");
		if(UnitId~=nil) then
			UnitId = UnitId:sub(1,10);
			local MyNPC_target = CurrentZoneId..":"..UnitId;
			local color = MyNPC_speakColor;
			if keywords=="" then
				keywords = MyNPC_OBSERVE;
				color = MyNPC_emoteColor;
			end
			
			local removeKey;
			local removeMessage = "";
			if MyNPCWords[MyNPC_adventure][MyNPC_target] ~= nil then
				for key,value in pairs(MyNPCWords[MyNPC_adventure][MyNPC_target]) do
					for i,word in pairs(value.Triggers) do
						if string.find(string.lower(keywords),string.lower(word)) ~= nil then
							removeKey = key;
							removeMessage = "->- "..MyNPC_target.." -> "..MyNPC_REMOVE.." -> "..MyNPCWords[MyNPC_adventure][MyNPC_target][key][0].." ("..word..")";
						end
					end
				end
			end
			
			if removeKey ~= nil then
				tremove(MyNPCWords[MyNPC_adventure][MyNPC_target], key);
				DEFAULT_CHAT_FRAME:AddMessage(removeMessage, color.r, color.g, color.b);
			end
			
			DEFAULT_CHAT_FRAME:AddMessage( "->- "..MyNPC_target.." -> "..answers.." ("..keywords..")", color.r, color.g, color.b );
			MyNPC_insertNPC(MyNPC_target, keywords, answers)
		else
			DEFAULT_CHAT_FRAME:AddMessage( "->- "..CurrentZoneId.." -> "..answers, MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b )
			MyNPC_insertZone(CurrentZoneId, answers)
		end
		MyNPC_KeyWordsEditBox:SetText("")
		MyNPC_AnswersEditBox:SetText("")
	end
end

function MyNPC_insertNPC(target, keywords, answers)
	keywords = strtrim(keywords)
	if MyNPCWords[MyNPC_adventure][target]==nil then
		MyNPCWords[MyNPC_adventure][target] = {}
	end
	local tableTriggers = {}
	while keywords~="" do
		local position = strfind(keywords, ":")
		if position~=nil then
			local word = strtrim(strsub(keywords, 0, position-1))
			if word~="" then
				tinsert(tableTriggers, strtrim(word))
			end
			keywords = strtrim(strsub(keywords, position+1))
		else
			tinsert(tableTriggers, strtrim(keywords))
			keywords = ""
		end
	end
	local tableAnswers = {
		Triggers = tableTriggers,
		[0] = answers
	}
	tinsert(MyNPCWords[MyNPC_adventure][target], tableAnswers)
end

function MyNPC_insertZone(zoneName, answers)
	MyNPCZones[MyNPC_adventure][zoneName] = answers
end

function MyNPC_Save()
	MyNPC_adventure_saved = MyNPC_adventure;
	MyNPCWords_saved = MyNPCWords[MyNPC_adventure_saved];
	MyNPCZones_saved = MyNPCZones[MyNPC_adventure_saved];
	DEFAULT_CHAT_FRAME:AddMessage("->- '"..MyNPC_adventure_saved.."' "..MyNPC_SAVED, MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b);
end
