-- Author      : Xamdnarg
-- Create Date : 4/13/2009 9:59:15 AM


function MyNPCDialogFrame_OnLoad(obj)
	DEFAULT_CHAT_FRAME:AddMessage(MyNPC_ONLOAD_MESSAGE);
	SlashCmdList["MyNPC"] = MyNPCDialogFrame_command;
	SLASH_MyNPC1 = "/mn";
	
	obj:RegisterEvent("PLAYER_TARGET_CHANGED");
	obj:RegisterEvent("ZONE_CHANGED");
	
	obj:SetScale(0.64);
end

function MyNPCDialogFrame_OnEvent()
	MyNPC_AdventureFontString:SetText(MyNPC_adventure);
	if(UnitName("target")~=nil) then
		MyNPC_NameFontString:SetText(UnitName("target"));
		SetPortraitTexture(MyNPC_Icon, "target");
	else
		local CurrentZoneName = MyNPC_getCurrentZoneName();
		MyNPC_NameFontString:SetText(CurrentZoneName);
		SetPortraitToTexture(MyNPC_Icon, "Interface\\BattlefieldFrame\\UI-Battlefield-Icon");
	end
	MyNPC_DialogFontString:SetText("");
end

function MyNPCDialogFrame_command(cmd)
	MyNPCDialogFrame_OnEvent();

	if MyNPCWords[MyNPC_adventure]==nil then
		MyNPCWords[MyNPC_adventure] = {};
	end
	if MyNPCZones[MyNPC_adventure]==nil then
		MyNPCZones[MyNPC_adventure] = {};
	end

	if cmd == "" then
		MyNPCFrames_Toggle(MyNPCDialogFrame);
	end
	if cmd == "save" then
		MyNPC_Save();
	end
	if cmd == "load" then
		MyNPC_Load();
	end
	if cmd == "create" then
		MyNPCFrames_Toggle(MyNPCCreateFrame);
	end
	if cmd == "adv" then
		DEFAULT_CHAT_FRAME:AddMessage("*** "..MyNPC_adventure.." ***");
	end
	local whereAdv = strfind(cmd, "adv ");
	if whereAdv == 1 then
		local cmd2 = strtrim(strsub(cmd, 5));
		if cmd2 ~= "" then
			MyNPC_adventure = cmd2;
			if MyNPCWords[MyNPC_adventure]==nil then
				MyNPCWords[MyNPC_adventure] = {};
			end
			if MyNPCZones[MyNPC_adventure]==nil then
				MyNPCZones[MyNPC_adventure] = {};
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage("*** "..MyNPC_adventure.." ***");
	end
end

function MyNPC_Load()
	if MyNPC_adventure_load~=nil then
		MyNPC_adventure = MyNPC_adventure_load;
		MyNPCWords[MyNPC_adventure] = MyNPCWords_load;
		MyNPCZones[MyNPC_adventure] = MyNPCZones_load;
		DEFAULT_CHAT_FRAME:AddMessage("->- '"..MyNPC_adventure.."' "..MyNPC_LOADED, MyNPC_emoteColor.r, MyNPC_emoteColor.g, MyNPC_emoteColor.b);

		MyNPCDialogFrame_OnEvent();
	end
end

function MyNPCFrames_Toggle(aFrame)
	if aFrame:IsVisible() then
		aFrame:Hide();
	else
		aFrame:Show();
	end
end

function MyNPCEdit_Process(obj)
	if strtrim(obj:GetText()) ~= "" then
		if(UnitName("target")~=nil) then
			MyNPC_talk(obj:GetText());
		end
		obj:SetText("");
	end
end

function MyNPCButton_Process()
	MyNPC_talk(MyNPC_OBSERVE);
end

function MyNPC_talk(text)
	local CurrentZoneId = GetCurrentMapContinent().."-"..GetCurrentMapZone();
	local UnitId = UnitGUID("target");
	if(UnitId~=nil) then
		UnitId = UnitId:sub(1,10);
		local MyNPC_target = CurrentZoneId..":"..UnitId;
		local nom = "";
		if(text~=MyNPC_OBSERVE) then
			nom = UnitName("target")..MyNPC_ISSAYING;
		end
		if MyNPCWords[MyNPC_adventure][MyNPC_target] ~= nil then
			for key,value in pairs(MyNPCWords[MyNPC_adventure][MyNPC_target]) do
				for i,word in pairs(value.Triggers) do
					if string.find(string.lower(text),string.lower(word)) ~= nil then
						MyNPC_DialogFontString:SetText(string.gsub(value[0], "'player'", UnitName("player")));
						
						color = MyNPC_speakColor;
						DEFAULT_CHAT_FRAME:AddMessage(nom..string.gsub(value[0], "'player'", UnitName("player")), color.r, color.g, color.b);
						return 0
					end
				end
			end
		end
		for key,value in pairs(Words[UnitFactionGroup("player")]) do
			for i,word in pairs(value.Triggers) do
				if string.find(string.lower(text),string.lower(word)) ~= nil then
					MyNPC_DialogFontString:SetText(value[math.floor(math.random()*value.Count)]);
					return 0
				end
			end
		end
		MyNPC_DialogFontString:SetText(Default[UnitFactionGroup("player")][math.floor(math.random()*Default[UnitFactionGroup("player")].Count)])
	else
		if MyNPCZones[MyNPC_adventure][CurrentZoneId] ~= nil then
			MyNPC_DialogFontString:SetText(MyNPCZones[MyNPC_adventure][CurrentZoneId]);
			
			color = MyNPC_emoteColor;
			DEFAULT_CHAT_FRAME:AddMessage(MyNPCZones[MyNPC_adventure][CurrentZoneId], color.r, color.g, color.b);
			return 0;
		else
			MyNPC_DialogFontString:SetText(MyNPC_NOTHINGTOSEE);
		end
	end

	--color = MyNPC_emoteColor;
	--DEFAULT_CHAT_FRAME:AddMessage(GetCurrentMapContinent(), color.r, color.g, color.b);
	--DEFAULT_CHAT_FRAME:AddMessage(GetCurrentMapZone(), color.r, color.g, color.b);
	--local guid = UnitGUID("target");
	--local mnid = guid:sub(1,10);
	--DEFAULT_CHAT_FRAME:AddMessage(mnid, color.r, color.g, color.b);
end
